"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = apiDeleteUser;
const deleteDbEntry_1 = __importDefault(require("../../backend/db/deleteDbEntry"));
const varDatabaseDbHandler_1 = __importDefault(require("../../backend/varDatabaseDbHandler"));
/**
 * # Update API User Function
 */
function apiDeleteUser(_a) {
    return __awaiter(this, arguments, void 0, function* ({ dbFullName, deletedUserId, }) {
        const existingUserQuery = `SELECT * FROM ${dbFullName}.users WHERE id = ?`;
        const existingUserValues = [deletedUserId];
        const existingUser = yield (0, varDatabaseDbHandler_1.default)({
            queryString: existingUserQuery,
            queryValuesArray: existingUserValues,
            database: dbFullName,
        });
        if (!(existingUser === null || existingUser === void 0 ? void 0 : existingUser[0])) {
            return {
                success: false,
                msg: "User not found",
            };
        }
        const deleteUser = yield (0, deleteDbEntry_1.default)({
            dbContext: "Dsql User",
            dbFullName,
            tableName: "users",
            identifierColumnName: "id",
            identifierValue: deletedUserId,
        });
        return {
            success: true,
            result: deleteUser,
        };
    });
}
