"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = setUserSchemaData;
const serverError_1 = __importDefault(require("./serverError"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
/**
 * # Set User Schema Data
 */
function setUserSchemaData({ userId, schemaData, }) {
    var _a;
    try {
        const userSchemaFilePath = path_1.default.resolve(process.cwd(), `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${userId}/main.json`);
        fs_1.default.writeFileSync(userSchemaFilePath, JSON.stringify(schemaData), "utf8");
        return true;
    }
    catch (error) {
        (0, serverError_1.default)({
            component: "/functions/backend/setUserSchemaData",
            message: error.message,
        });
        (_a = global.ERROR_CALLBACK) === null || _a === void 0 ? void 0 : _a.call(global, `Error Setting User Schema`, error);
        return false;
    }
}
