"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("dotenv").config({ path: "./../.env" });
const serverError_1 = __importDefault(require("../functions/backend/serverError"));
const noDatabaseDbHandler_1 = __importDefault(require("./utils/noDatabaseDbHandler"));
/**
 * # Create Database From Schema
 */
function grantFullPrivileges(_a) {
    return __awaiter(this, arguments, void 0, function* ({ userId }) {
        /**
         * Grab Schema
         *
         * @description Grab Schema
         */
        try {
            const defaultMariadbUserHost = process.env.DSQL_DB_HOST || "127.0.0.1";
            const allDatabases = yield (0, noDatabaseDbHandler_1.default)(`SHOW DATABASES`);
            const datasquirelUserDatabases = allDatabases.filter((/** @type {any} */ database) => database.Database.match(/datasquirel_user_/));
            for (let i = 0; i < datasquirelUserDatabases.length; i++) {
                const datasquirelUserDatabase = datasquirelUserDatabases[i];
                const { Database } = datasquirelUserDatabase;
                // const grantDbPriviledges = await noDatabaseDbHandler(
                //     `GRANT ALL PRIVILEGES ON ${Database}.* TO '${process.env.DSQL_DB_FULL_ACCESS_USERNAME}'@'%' WITH GRANT OPTION`
                // );
                // const grantRead = await noDatabaseDbHandler(
                //     `GRANT SELECT ON ${Database}.* TO '${process.env.DSQL_DB_READ_ONLY_USERNAME}'@'%'`
                // );
            }
            const flushPriviledged = yield (0, noDatabaseDbHandler_1.default)(`FLUSH PRIVILEGES`);
        }
        catch ( /** @type {any} */error) {
            (0, serverError_1.default)({
                component: "shell/grantDbPriviledges/main-catch-error",
                message: error.message,
                user: { id: userId },
            });
        }
        process.exit();
    });
}
const userArg = process.argv[process.argv.indexOf("--user")];
const externalUser = process.argv[process.argv.indexOf("--user") + 1];
grantFullPrivileges({ userId: userArg ? externalUser : null });
