"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = parseEnv;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
function parseEnv(/** Env File Path */ envPath) {
    let obj = {};
    const finalEnvPath = path_1.default.resolve(process.cwd(), envPath);
    const envFile = fs_1.default.readFileSync(finalEnvPath, "utf-8");
    const envLinesArr = envFile
        .split(/\r\n|\n|\r/)
        .filter((ln) => ln.match(/\=/));
    envLinesArr.forEach((ln) => {
        const keyValArr = ln.split("=");
        obj[keyValArr[0]] = keyValArr[1] || "";
    });
    return obj;
}
