import fs from "fs";
import path from "path";

export default function parseEnv(/** Env File Path */ envPath: string) {
    let obj: { [k: string]: string } = {};
    const finalEnvPath = path.resolve(process.cwd(), envPath);
    const envFile = fs.readFileSync(finalEnvPath, "utf-8");
    const envLinesArr = envFile
        .split(/\r\n|\n|\r/)
        .filter((ln) => ln.match(/\=/));

    envLinesArr.forEach((ln) => {
        const keyValArr = ln.split("=");
        obj[keyValArr[0]] = keyValArr[1] || "";
    });

    return obj;
}
